﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel.Security;
using System.Web.Security;
using HLWebOKBAdminPlugin.OKBAdministrationService;

namespace HLWebPluginHost.Models {
    public class AlgorithmClassModel {

        private AdministrationServiceClient CertificateValidator() {
            AdministrationServiceClient asc = new AdministrationServiceClient();

            asc.ClientCredentials.UserName.UserName = Membership.GetUser().UserName;
            asc.ClientCredentials.UserName.Password = HttpContext.Current.Session["pwd"].ToString();
            asc.ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.None;

            return asc;
        }//CertificateValidator

        public int NumOfClasses { get; set; }
        public List<AlgorithmClass> AlgorithmClassList { get; set; }

        public List<AlgorithmClass> AlgorithmClassGetAll() {
            //returns list of algorithm classes            
            AdministrationServiceClient asc = CertificateValidator();

            var agcList = new List<AlgorithmClass>();

            AlgorithmClass[] ac = asc.GetAlgorithmClasses();
            foreach (AlgorithmClass a in ac) {
                agcList.Add(a);

            }//foreach

            return agcList;
        }//AlgorithmClassGetAll

        //Add AlgorithmClass table entry
        public bool AddAlgorithmClass(string name, string description) {
            long retValue;
            //get service client
            AdministrationServiceClient asc = CertificateValidator();

            AlgorithmClass ac = new AlgorithmClass();
            //test
            //ac.Id = 8;
            ac.Name = name;
            ac.Description = description;
            retValue = asc.AddAlgorithmClass(ac);
            
            return true;
        }//AddAlgorithmClass
    }
}